; File name / path processing functions by Dark$oul71
;
; AutoIt sources, http://www.hiddensoft.com/AutoIt/
;
; Contact Dark$oul71 via email to darksoul71@gmx.de

#include "File.au3"

;----------------------------------------------------------------------------------
Func _FileGetDrive ($FullPath)
  ; Define local variables
  Local $tmpDrive = ""
  Local $tmpDir   = ""
  Local $tmpName  = ""
  Local $tmpExt   = ""
  Local $tmpDrive = ""

  _PathSplit($FullPath, $tmpDrive, $tmpDir, $tmpName, $tmpExt)

  Return ($tmpDrive)

EndFunc
;----------------------------------------------------------------------------------
Func _FileGetPath ($FullPath)
  ; Define local variables
  Local $tmpDrive = ""
  Local $tmpDir   = ""
  Local $tmpName  = ""
  Local $tmpExt   = ""
  Local $tmpDrive = ""

  _PathSplit($FullPath, $tmpDrive, $tmpDir, $tmpName, $tmpExt)

  Return ($tmpDrive & $tmpDir)

EndFunc
;----------------------------------------------------------------------------------
Func _FileGetFilename ($FullPath)
  ; Define local variables
  Local $tmpDrive = ""
  Local $tmpDir   = ""
  Local $tmpName  = ""
  Local $tmpExt   = ""
  Local $tmpDrive = ""

  _PathSplit($FullPath, $tmpDrive, $tmpDir, $tmpName, $tmpExt)

  Return ($tmpName & $tmpExt)
EndFunc
;----------------------------------------------------------------------------------
Func _FileGetExt ($FullPath)
  ; Define local variables
  Local $tmpDrive = ""
  Local $tmpDir   = ""
  Local $tmpName  = ""
  Local $tmpExt   = ""
  Local $tmpDrive = ""

  _PathSplit($FullPath, $tmpDrive, $tmpDir, $tmpName, $tmpExt)

  Return ($tmpExt)
EndFunc
;----------------------------------------------------------------------------------
Func _FileChangeExt ($FullPath, $Extension)
  
  If (StringLeft ($Extension, 1) <> ".") Then $Extension = "." & $Extension

  ; Define local variables
  Local $tmpDrive = ""
  Local $tmpDir   = ""
  Local $tmpName  = ""
  Local $tmpExt   = ""
  Local $tmpDrive = ""

  _PathSplit($FullPath, $tmpDrive, $tmpDir, $tmpName, $tmpExt)

  Return (StringReplace ($FullPath, $tmpExt,$Extension))
EndFunc
;----------------------------------------------------------------------------------
Func _FileStripExt ($FullPath)
 ; Define local variables
  Local $tmpDrive = ""
  Local $tmpDir   = ""
  Local $tmpName  = ""
  Local $tmpExt   = ""
  Local $tmpDrive = ""

  _PathSplit($FullPath, $tmpDrive, $tmpDir, $tmpName, $tmpExt)

  Return ($tmpDrive & $tmpDir & $tmpName)
EndFunc
;----------------------------------------------------------------------------------
Func _FileIncrementFileName ($FullPath)

  If FileExists($FullPath) Then

    ; Define local variables
    Local $tmpDrive = ""
    Local $tmpDir   = ""
    Local $tmpName  = ""
    Local $tmpExt   = ""
    Local $tmpDrive = ""

    _PathSplit($FullPath, $tmpDrive, $tmpDir, $tmpName, $tmpExt)

    $Count = 1

    $ReturnName =  $tmpDrive & $tmpDir & $tmpName & " (" & $Count & ")" & $tmpExt

    While FileExists ($ReturnName)
      $Count = $Count + 1
      $ReturnName =  $tmpDrive & $tmpDir & $tmpName & " (" & $Count & ")" & $tmpExt
    Wend

    Return ($ReturnName)
  Else
    Return ($FullPath)
  EndIf
EndFunc
;----------------------------------------------------------------------------------
Func _DrivePercentFree ($FullPath)
  ; Define local variables
  Local $tmpDrive = ""
  Local $tmpDir   = ""
  Local $tmpName  = ""
  Local $tmpExt   = ""
  Local $tmpDrive = ""

  _PathSplit($FullPath, $tmpDrive, $tmpDir, $tmpName, $tmpExt)

  If (DriveStatus ($tmpDrive) <> "READY") Then Return (-1)

  $SizeTotal = DriveSpaceTotal ($tmpDrive)
  $SizeFree  = DriveSpaceFree  ($tmpDrive)

  Return (Round ($SizeFree / ($SizeTotal*0.01),2))
EndFunc
;----------------------------------------------------------------------------------
Func _IsSearchedType ($FullPath, $Types)

  $SearchedTypes = StringSplit ( $Types, "|,;:" )

  $SearchCount = $SearchedTypes[0]

  For $i = 1 To $SearchCount
    $SearchedTypes[$i] = StringUpper($SearchedTypes[$i])
    If (StringLeft ($SearchedTypes[$i], 1) <> ".") Then $SearchedTypes[$i] = "." & $SearchedTypes[$i]
  Next

  ; Define local variables
  Local $tmpDrive = ""
  Local $tmpDir   = ""
  Local $tmpName  = ""
  Local $tmpExt   = ""
  Local $tmpDrive = ""

  _PathSplit($FullPath, $tmpDrive, $tmpDir, $tmpName, $tmpExt)
  
  For $i = 1 To $SearchCount
    If ($SearchedTypes[$i] = StringUpper($tmpExt)) Then Return (1)
  Next

  Return (0)
EndFunc
;----------------------------------------------------------------------------------